---
stages:
  - validate
  - build
  - test
  - cleanup

variables:
  PACKER_IMAGE_VERSION: v0.1.0
  PACKER_IMAGE_NAME: packer-runner-test

docker-build-a-container:
  stage: build
  variables:
    DOCKER_IMAGE_NAME: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  before_script:
    - echo $CI_REGISTRY "$CI_DEPLOY_USER"
    - docker login -u "$CI_DEPLOY_USER" -p "$CI_DEPLOY_PASSWORD" $CI_REGISTRY
  script: |
    docker build -t "$DOCKER_IMAGE_NAME" .
    docker push "$DOCKER_IMAGE_NAME"
    if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
      docker tag "$DOCKER_IMAGE_NAME" "$CI_REGISTRY_IMAGE:latest"
      docker push "$CI_REGISTRY_IMAGE:latest"
    fi
    docker images
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - Dockerfile 
  tags:
    - shell

test-in-a-container:
  stage: test
  image: $CI_REGISTRY_IMAGE:latest 
  script: | 
    echo "CI_REGISTRY_IMAGE: $CI_REGISTRY_IMAGE"
    echo "CI_COMMIT_REF_SLUG: $CI_COMMIT_REF_SLUG"
    echo "CI_DEPLOY_USER: $CI_DEPLOY_USER"
    echo "CI_REGISTRY: $CI_REGISTRY"
    echo "CI_PROJECT_NAMESPACE: $CI_PROJECT_NAMESPACE"
    echo "CI_COMMIT_BRANCH: $CI_COMMIT_BRANCH"
    echo "CI_DEFAULT_BRANCH: $CI_DEFAULT_BRANCH"
  tags:
    - docker

docker-cleanup:
  stage: cleanup
  variables:
    DOCKER_IMAGE_NAME: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  script: 
    - docker rmi "$CI_REGISTRY_IMAGE:latest"
    - docker rmi "$DOCKER_IMAGE_NAME"
    - docker images
  tags:
    - shell 

validate-packer:
  stage: validate
  variables:
    CI_REG_NAME: $CI_REGISTRY_IMAGE
    CI_IMAGE_TAG: $PACKER_IMAGE_NAME
  before_script:
    - packer init .
  script:
    - packer fmt .
    - packer validate .
  tags:
    - packer

build-with-packer:
  stage: build
  variables:
    CI_REG_NAME: $CI_REGISTRY_IMAGE
    CI_IMAGE_TAG: $PACKER_IMAGE_NAME
  script:
    - packer build --var image_version=$PACKER_IMAGE_VERSION .
  tags:
    - packer

test-packer:
  stage: test
  script:
    - docker images 
    - docker images $CI_REGISTRY_IMAGE
    - docker images $CI_REGISTRY_IMAGE:$PACKER_IMAGE_VERSION -q
    - docker images $CI_REGISTRY_IMAGE:$PACKER_IMAGE_NAME -q
  tags:
    - packer

packer-cleanup:
  stage: cleanup
  script: 
    - docker rmi $CI_REGISTRY_IMAGE:$PACKER_IMAGE_VERSION
    - docker rmi $CI_REGISTRY_IMAGE:$PACKER_IMAGE_NAME 
    - docker images
  tags:
    - packer

validate-terraform:
  stage: validate
  before_script: 
    - terraform init
  script:
    - terraform fmt
    - terraform validate
  tags:
    - terraform

terraform-build:
  stage: build
  before_script:
    - terraform init
    - terraform plan > tf.plan
  script:
    - terraform apply -auto-approve
    - terraform state list
  tags:
    - terraform

terraform-cleanup:
  stage: cleanup
  script:
    - rm -rf .terraform
  tags:
    - terraform
